require File.dirname(__FILE__) + '/../test_helper'
require 'journals_controller'

# Re-raise errors caught by the controller.
class JournalsController; def rescue_action(e) raise e end; end

class JournalsControllerTest < Test::Unit::TestCase
  fixtures :journals

  def setup
    @controller = JournalsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:journals)
  end

  def test_show
    get :show, :id => 1

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:journal)
    assert assigns(:journal).valid?
  end

  def test_create
    num_journals = Journal.count

    post :create, :journal => {
      :"date(1i)" => "2006",
      :"date(2i)" => "8",
      :"date(3i)" => "10",
      :amount => "1000",
      :creditor_id => "4",
      :debtor_id => "1",
      :text => "tag1 tag2 tag3"
    }
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_journals + 1, Journal.count
  end

  def test_edit
    get :edit, :id => 1

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:journal)
    assert assigns(:journal).valid?
  end

  def test_update
    post :update, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => 1
  end

  def test_destroy
    assert_not_nil Journal.find(1)

    post :destroy, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Journal.find(1)
    }
  end
end
